#include <iostream>
#include <string>

#include "Birthday7.h"
#include "SafeArray7.h"
using namespace std;

template <typename T>
void print(SafeArray<T> a);

void test_int();
void test_string();
void test_birthday();

int main()
{
    test_int();       cout << endl;
    test_string();    cout << endl;
    test_birthday();  cout << endl;

    cout << "Done!" << endl;
    return 0;
}

template <typename T>
void print(SafeArray<T> a)
{
    for (int i = 0; i < a.get_length(); i++) cout << " " << a[i];
    cout << endl;
}

void test_int()
{
    SafeArray<int> a1(10), a2, a3;

    for (int i = 0; i < 10; i++) a1[i] = 10*i;

    a3 = a2 = a1;
    a1[4] = -a1[4];

    cout << "a1 ="; print(a1);
    cout << "a2 ="; print(a2);
    cout << "a3 ="; print(a3);
}

void test_string()
{
    SafeArray<string> a1(4), a2, a3;

    a1[0] = "Fee";
    a1[1] = "Fie";
    a1[2] = "Foe";
    a1[3] = "Fum";

    a3 = a2 = a1;
    a1[2] = "XXX";

    cout << "a1 ="; print(a1);
    cout << "a2 ="; print(a2);
    cout << "a3 ="; print(a3);
}

void test_birthday()
{
    Birthday bd0;
    Birthday bd1(1981, 9, 2);
    Birthday bd2(1992, 5, 8);
    Birthday bd3(1963, 1, 1);

    SafeArray<Birthday> a1(3), a2, a3;

    a1[0] = bd0;
    a1[1] = bd1;
    a1[2] = bd2;

    a3 = a2 = a1;
    a1[2] = bd3;

    cout << "a1 ="; print(a1);
    cout << "a2 ="; print(a2);
    cout << "a3 ="; print(a3);
}
